( cefSIMa.F, 11sep09cht, for c_eForth )
( All numbers are 32-bit, no need of carry extension)

HEX

$1F CONSTANT LIMIT ( stack depth )
$7FFF CONSTANT RANGE ( program memory size in words )
VARIABLE CLOCK ( slot is in the last 2 bits )
VARIABLE BREAK

CREATE REGISTER $300 ALLOT
: C+! DUP >R C@ + R> C! ;

DECIMAL
REGISTER CONSTANT P
REGISTER 4 + CONSTANT I
REGISTER 8 + CONSTANT I1
REGISTER 9 + CONSTANT I2
REGISTER 10 + CONSTANT I3
REGISTER 11 + CONSTANT I4
\ REGISTER 12 + CONSTANT I5
REGISTER 13 + CONSTANT RP
REGISTER 14 + CONSTANT SP
REGISTER 16 + CONSTANT T
REGISTER 24 + CONSTANT IP
REGISTER 32 + CONSTANT WP
REGISTER $100 + CONSTANT RSTACK0
REGISTER $200 + CONSTANT SSTACK0

HEX
: RSTACK  RP C@ LIMIT AND 2 LSHIFT RSTACK0 + ;
: SSTACK  SP C@ LIMIT AND 2 LSHIFT SSTACK0 + ;

: CYCLE 1 CLOCK +! ;
: JUMP  CLOCK @ 7 OR CLOCK ! ;
: RPUSH ( n -- , push n on return stack )
        1 RP C+! RSTACK ! ;
: RPOPP ( -- n , pop n from return stack )
        RSTACK @ -1 RP C+! ;
: SPUSH ( n -- , push n on data stack )
        1 SP C+! 
        T @ SSTACK !
        T ! ;
: SPOPP ( -- n , pop n from data stack )
        T @
        SSTACK @ T ! 
	-1 SP C+! ;
: continue
        P @ RAM@ DUP I !
        100 /MOD SWAP I1 C!
        100 /MOD SWAP I2 C!
        100 /MOD SWAP I3 C!
        FF AND I4 C!
	4 P +! ;
: next,	IP @ RAM@ P !
	4 IP +! JUMP ;

: nop,    JUMP ;
: bye,    ABORT" Simulation done." ;
\ : qrx,    ?RX ?DUP IF SPUSH -1 ELSE 0 THEN SPUSH ;
: qrx,    KEY DUP SPUSH SPUSH ;
: txsto,  SPOPP TX! ;
: inline, P @ RAM@ SPUSH 4 P +! ;
: dolit,  IP @ RAM@ SPUSH 4 IP +! next, ;
: dolist, IP @ RPUSH P @ IP ! next, ;
: exit,   RPOPP IP ! next, ;
: execu,  IP @ RPUSH SPOPP P ! JUMP ;
: donext, RPOPP ?DUP IF 1- RPUSH IP @ RAM@ IP !
	  ELSE 4 IP +! THEN next, ;
: qbran,  SPOPP IF 4 IP +! ELSE IP @ RAM@ IP ! THEN next, ;
: bran,   IP @ RAM@ IP ! next, ;
: store,  SPOPP SPOPP SWAP RAM! ;
: at,     SPOPP RAM@ SPUSH ;
: cstor,  SPOPP SPOPP SWAP RAMC! ;
: cat,    SPOPP RAMC@ SPUSH ;
: rpat,   B0 RAM@ SPUSH ;
: rpsto,  SPOPP B0 RAM! ;
: rfrom,  RPOPP SPUSH ;
: rat,    RPOPP DUP RPUSH SPUSH ;
: tor,    SPOPP RPUSH ;
: spat,   B4 RAM@ SPUSH ;
: spsto,  SPOPP B4 RAM! ;
: drop,   SPOPP DROP ;
: dup,    SPOPP DUP SPUSH SPUSH ;
: swap,   SPOPP SPOPP SWAP SPUSH SPUSH ;
: over,   SPOPP SPOPP DUP SPUSH SWAP SPUSH SPUSH ;
: zless,  SPOPP 0< SPUSH ;
: andd,   SPOPP SPOPP AND SPUSH ;
: orr,    SPOPP SPOPP OR SPUSH ;
: xorr,   SPOPP SPOPP XOR SPUSH ;
: uplus,  SPOPP SPOPP UM+ SWAP SPUSH SPUSH ;
: qdup,   SPOPP DUP SPUSH ?DUP IF SPUSH THEN ;
: rot,    SPOPP SPOPP SPOPP ROT ROT SPUSH SPUSH SPUSH ;
: ddrop,  SPOPP SPOPP 2DROP ;
: ddup,   SPOPP SPOPP 2DUP SPUSH SPUSH SPUSH SPUSH ;
: plus,   SPOPP SPOPP + SPUSH ;
: inver,  SPOPP NOT SPUSH ;
: negat,  SPOPP NEGATE SPUSH ;
: dnega,  SPOPP SPOPP SWAP DNEGATE SWAP SPUSH SPUSH ;
: subb,   SPOPP SPOPP SWAP - SPUSH ;
: abss,   SPOPP ABS SPUSH ;
: equal,  SPOPP SPOPP = SPUSH ;
: uless,  SPOPP SPOPP SWAP U< SPUSH ;
: less,   SPOPP SPOPP SWAP < SPUSH ;
: ummod,  SPOPP SPOPP SPOPP SWAP ROT UM/MOD SWAP SPUSH SPUSH ;
: msmod,  SPOPP SPOPP SPOPP SWAP ROT M/MOD SWAP SPUSH SPUSH ; 
: slmod,  SPOPP SPOPP SWAP /MOD SWAP SPUSH SPUSH ;
: mod, 	  SPOPP SPOPP SWAP MOD SPUSH ;
: slash,  SPOPP SPOPP SWAP / SPUSH ; 
: umsta,  SPOPP SPOPP UM* SWAP SPUSH SPUSH ;	 
: star,   SPOPP SPOPP * SPUSH ;
: mstar,  SPOPP SPOPP M* SWAP SPUSH SPUSH ; 
: ssmod,  SPOPP SPOPP SPOPP SWAP ROT */MOD SWAP SPUSH SPUSH ; 
: stasl,  SPOPP SPOPP SPOPP SWAP ROT */ SPUSH ; 
: pick,   SPOPP SP C+! SSTACK SPUSH ;
: pstor,  SPOPP SPOPP OVER RAM@ + SWAP RAM! ;
: dstor,  SPOPP SPOPP OVER CELL+ RAM! SPOPP SWAP RAM! ;
: dat,    SPOPP DUP RAM@ SPUSH CELL+ RAM@ SPUSH ;
: count,  SPOPP DUP 1+ SPUSH RAMC@ SPUSH ;
: dovar,  P @ SPUSH ;
: max,    SPOPP SPOPP MAX SPUSH ;
: min,    SPOPP SPOPP MIN SPUSH ;

HEX

: ERR  . 1 ABORT" :Illegel :ruction" ;

CREATE CODE-TABLE
' nop,    , ' bye,    , ' qrx,    , ' txsto, , 
' inline, , ' dolit,  , ' dolist, , ' exit,  , 
' execu,  , ' donext, , ' qbran,  , ' bran,  , 
' store,  , ' at,     , ' cstor,  , ' cat,   , 
' rpat,   , ' rpsto,  , ' rfrom,  , ' rat,   , 
' tor,    , ' spat,   , ' spsto,  , ' drop,  , 
' dup,    , ' swap,   , ' over,   , ' zless, , 
' andd,   , ' orr,    , ' xorr,   , ' uplus, , 
' next,   , ' qdup,   , ' rot,    , ' ddrop, , 
' ddup,   , ' plus,   , ' inver,  , ' negat, , 
' dnega,  , ' subb,   , ' abss,   , ' equal, , 
' uless,  , ' less,   , ' ummod,  , ' msmod, , 
' slmod,  , ' mod,    , ' slash,  , ' umsta, , 
' star,   , ' mstar,  , ' ssmod,  , ' stasl, , 
' pick,   , ' pstor,  , ' dstor,  , ' dat,   , 
' count,  , ' dovar,  , ' max,    , ' min,   ,

: executecode ( code -- )
   DUP 3F > ABORT" Illegal code "
   CELLS CODE-TABLE + @ EXECUTE ;

: .stack ( add # ) FOR AFT DUP @ U. 4 - THEN NEXT DROP CR ;
: .sstack ." S:" T @ U.
        SSTACK SP C@ .stack ;
: .rstack ." R:" RSTACK RP C@ .stack ;
: .registers ."  P=" P @ . ."  I=" I @ U.
        ."  I1=" I1 C@ . ."  I2=" I2 C@ .
        ."  I3=" I3 C@ . ."  I4=" I4 C@ .
        ."  IP=" IP @ . CR ;
: S  CR ."  CLOCK=" CLOCK @ . .registers
        .sstack .rstack ;

: SYNC0  continue ;
: SYNC1  I1 C@ executecode ;
: SYNC2  I2 C@ executecode ;
: SYNC3  I3 C@ executecode ;
: SYNC4  I4 C@ executecode ;

CREATE SYNC-TABLE
' continue , ' SYNC1 , ' SYNC2 , ' SYNC3 ,
' SYNC4 , ' JUMP , ' JUMP , ' JUMP ,

: sync  CLOCK @ 7 AND cells
        SYNC-TABLE + @ EXECUTE ;
: C     sync CYCLE S ;
: RESET REGISTER $300 ERASE 0 CLOCK ! 
	;
RESET

: G     ( addr -- )
        CR ." Press any key to stop." CR
        BREAK !
        BEGIN sync P @ BREAK @ =
              IF CYCLE C EXIT
              ELSE CYCLE
              THEN
              ?KEY
        UNTIL ;
: PUSH  ( n ) T @ SPUSH T ! ;
: POP   SPOPP ;

: D     P @ CELL- FOUR FOUR ;
: M     SHOW ;
: RUN   CR ." Press ESC to stop." CR
        BEGIN C KEY 1B = UNTIL ;

: HELP  CR ." cEF Simulator, copyright Offete Enterprises, 2009"
        CR ." C: execute next cycle"
        CR ." S: show all registers"
        CR ." D: display next 8 words"
        CR ." addr M: display 128 words from addr"
        CR ." addr G: run and stop at addr"
        CR ." RUN: execute, one key per cycle"
        CR ;

